//+------------------------------------------------------------------+
//|                                            http://www.netgame.eu |
//+------------------------------------------------------------------+
#property copyright "Copyright FiFtHeLeMeNt/J Talon LLC/II. Valentinus  2007-2009, ."
#property link      "http://www.netgame.eu"
#define NAME		"The Blessing Centurion"

//#define ANN_PATH	"c:\\Users\\David\\Forex\\ANN\\"
//#define ANN_PATH	"D:\\FX\\MT4\\ANN\\"
#define ANN_PATH	"C:\\ANN\\"

#define  NL    "\n"

extern string  InitialAccountSet   = "Initial account balance";
extern int     InitialAccount      = 1000; 

extern string  TradeComment        = "Part of the II. Legion";

extern string  NumberPortionSet    = "Account Portion";
extern int     Portion             = 1;    // Portion of account you want to trade on this pair

extern bool    UseEquityProtection = true; // Close all orders when negative Float is excessive.
extern double  FloatPercent        = 50;   // Percent of portion for max Float level.
extern bool    UsePowerOutSL       = true;   

extern bool    UseMM               = 1;    // Money Management - 1 = true & 0 = false.

extern string  LotAdjustmentSet    = "Only with MM enabled. (.01 - 5.0)";
extern double  LAF                 = 0.01;  // Adjusts MM base lot for large accounts

extern string  AccountTypeSet      = "1=standard, 10=micro for penny/pip)";
extern int     Accounttype         = 10;    // Used in Money Management feature only.

extern string  ManuallotSet        = "Lots used if MM is off";
extern double  lot                 = 0.01; // Starting lots if Money Management is off

extern string  LotHedgeSet         = "Hedge Multiplier.  Adjust by +/-.01 intervals ";
extern double  Multiplier          = 1.2;  // Multiplier on each level

extern string  AutoParametersSet   = "Autocalculates the Grid based on ATR";
extern bool    AutoCal             = true; // Auto calculation of TakeProfit and Grid size;
extern int     AutoCalTF           = 1440;
extern int     AutoCalPeriod       = 21;

extern string  AutoGridAdjust      = "Widens/squishes grid (.5 - 3.0)";
extern double  GAF                 = 1.4;  // Widens/Squishes Grid on increments/decrements of .1

extern string  GridSet             = "Default Grid size in Pips";
extern int     PF                  = 1;    // Multiplier for TakeProfit, Profitfactor
extern int     OffSet              = 25;   // OffSet for Moving to BE
extern int     TrailingStop        = 50;    // TrailingStop for Orders in Profit
extern int     GridSet1            = 25;   // Set 1 Grid Size
extern int     TP_Set1             = 50;   // Set 1 Take Profit
extern int     GridSet2            = 50;   // Level 2 Grid Size
extern int     TP_Set2             = 100;  // Level 2 Take Profit
extern int     GridSet3            = 100;  // Level 3 Grid Size
extern int     TP_Set3             = 200;  // Level 3 Take Profit

extern string  TimeGridSet         = "Default grid set time in seconds";
extern int     TimeGrid            = 2400; // Time Grid in seconds , to avoid opening of lots of levels in fast market

extern string  MarketConditionSet  = "Set MC to 2 for Ranging Market";
extern int     MC                  = 2;    // Market condition 0=uptrend 1=downtrend 2=range

extern string  MovingAverageSet    = "Changes MC for correct trend (up/down)";
extern bool    MCbyMA              = true; // Defines market condition by EMA , if price is above EMA,
                                           // it will take it as an uptrend and goes only long,
                                           // vice versa for below the EMA
extern int     MA_Type             = MODE_SMA; //Linear wighted or Simple or Exponential                                           
extern int     MA_Period           = 99;   // Period of MA
extern int     MA_TimeFrame        = 0;   //0, 1, 15, 30, 60 for MA timeframe

extern double  SAR_Trend           = 0.001;

// Only if MCbyMA == true
extern int     ForceP              = 34;

extern string  DeMarkerSet         = "Changes DaMarker for correct trend (up/down)";
extern int     DeMark_TimeFrame    = 0;    //0, 1, 15, 30, 60 for MA timeframe
extern int     DeMark_Period       = 34;    // Period of DeMarker
extern double  DeMark_Sell_Zone    = 0.6;   // Sell Zone of DeMarker
extern double  DeMark_Buy_Zone     = 0.4;   // Buy Zone of DeMarker
// Only if MCbyMA == true



extern bool    MCEmergencyStop     = true; //Closes positions if the MA shows change (after strong uptrend it turns but MA still shows uptrend)
extern double  MCEmergencyValue    = -30; // After trend change, what is the max amount that it should go down




extern string  MaxLevelSet         = "Default of 4 on each level, change sparingly";
extern int     Set1Count           = 4;    // Level 1 max levels
extern int     Set2Count           = 4;    // Level 2 max levels
extern int     MaxLevel            = 99;   // Level 2 max levels (stops placing orders when reaches maxlvl2)
extern int     BELevel             = 12;   // Close All level , when reaches this level, doesn't wait for TP to be hit

extern int     slippage            = 999; // Tolerance of order slips/requotes for closing

extern string  StochText           = "Set to False if you dont Want Stochastic Indicator";
extern bool    Stoch               = true;
extern int     per_K               = 120; // Stochastic parameters:
extern int     per_D               = 20;
extern int     slow                = 20;
extern int     zoneBUY             = 20;
extern int     zoneSELL            = 80;


extern string  OsMAText           = "Set to False if you dont Want OsMA Indicator";
extern bool    OsMA               = true;
extern int     FastEMA            = 100; // OsMA Parameters:
extern int     SlowEMA            = 20;
extern int     Signal             = 90;


extern string  SARText            = "Set to False if you dont Want SAR Indicator";
extern bool    SAR                = true;
extern double  SAR_Step           = 0.05; // SAR Parameters:
extern double  SAR_Max            = 0.2;

extern string  WilliamsText       = "Set to False if you dont want Williams Indicator";
extern bool    Williams           = true;
extern int     WilliamsP          = 70;
extern int     WilliamsL          = -80;
extern int     WilliamsH          = -20;

extern string  BollingerText      = "Set to False if you dont want Bollinger Bands Indicator";
extern bool    Bollinger          = true;
int            BPeriod            = 15;
double         Deviation          = 2.0;
double         BDistance          = 13;


extern string  RSIText            = "Set to False if you dont want RSI Indicator";
extern bool    RSI                = true;
extern int     RSI_Period         = 14;
extern int     RSI_BuyZone        = 30;
extern int     RSI_SellZone       = 70;

extern string  IndicatorsText     = "Set the percentage that has to show the same trend (ex: 0.5 (50%) means that at least 2.5 (rounded to 3) of the indicators must say the same ";
extern double  IndicatorsPercent  = 0.51;



extern string TheBigFriday         = "Setting for friday positions close";
extern bool   CloseOnFriday        = false;
extern int    FridayCloseHour      = 21; // will be used only if CloseOnFriday == true
extern int    FridayCloseMinute    = 00; // will be used only if CloseOnFriday == true


extern string MarketOC             = "Setting for trade time account protection";
extern bool   TradeDelay           = false;
extern int    NYOpenHour           = 03; // New York
extern int    NYCloseHour          = 21; // New York
extern int    TokyoOpenHour        = 01; // Tokyo
extern int    TokyoCloseHour       = 07; // Tokyo
extern int    LondonOpenHour       = 10; // London
extern int    LondonCloseHour      = 16; // London

//+------------------------------------------------------------------+
//| Socket suck it                                                   |
//+------------------------------------------------------------------+
//#include <MT4_Socket_Layer.mqh>



//+------------------------------------------------------------------+
//| Internal Parameters Set                                          |
//+------------------------------------------------------------------+

bool           ca                  = false;
string         EA_name             = "II. Centurion";
int            magic               = 0;
double         slip                = 0;       
int            d                   = 5;      // Used to offset entry to round numbers , for example if you set d=5,
                                             // it will place its sell order on 1.5795 instead of 1.5780
double         LotInc              = 0;      // Lot Increment on each level, very dangerous
string         Filename;
int            BrokerDecimal       = 1;
string         POSL_On             = "Yes";
int            count;
double         PortionBalance;
double         InitialAccountMultiPortion;
double         PortionEquity;
string         trendUpDown         = "";
double         DD;
double         MaxDD;
double         MaxDDpercent;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {
   int i, ann;
   
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") magic = 101101;
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") magic = 101102;
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") magic = 101103;
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") magic = 101104;
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") magic = 101105;
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") magic = 101106;
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") magic = 101107;
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") magic = 101108;
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") magic = 101109;
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") magic = 101110;
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") magic = 101111;
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") magic = 101112;
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") magic = 101113;
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") magic = 101114;
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") magic = 101115;
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") magic = 101116;
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") magic = 101117;
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") magic = 101118;
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") magic = 101119;
   
   if (magic == 0) magic = 701999;
   
   if(Digits==3 || Digits==5) BrokerDecimal = 10;
   
   Filename = StringConcatenate(EA_name+"_",Symbol(),"_",Period(),"_M",".txt"); 
   
   return(0);
  }
  


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {
   int i;


   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
   double train_output[1];
   int y;
   int cb=0; // Count buy
   int cs=0; // Count sell
   int cbl=0; // Count buy limit
   int csl=0; // Count sell limit
   int cbs=0; // Count buy limit
   int css=0; // Count sell limit
   double tbl=0; //Count lot size
   double tsl=0; //Count lot size
   double tl=0; //total lots out
   double to=0; //total buy and sell order out
   double buysl=0; //stop losses are set to zero if POSL off
   double sellsl=0; //stop losses are set to zero if POSL off
   double POSL=0; //Initialize POSL
   double m,lot2;
   double lp; // last buy price
   double ll; //last lot
   double ltp; //last tp
   double lopt; // last open time
   double g2;
   double tp2;
   double entry;
   double pr=0; // profit;
   double sumlot;
   int lticket;
   double mp,mp2; // median price
   string query="";
   int length=0;
   int MA_Period_Fast = MA_Period / 3;
	double ma;
	double stddev;
	double bup, bux;
	double bdn, bdx;
	bool CloseBuySellLimitOrders = false;
   
   /* Prepare and run neural networks */

   // Bollinger

   ma = iMA(Symbol(),0,BPeriod,0,MODE_SMA,PRICE_OPEN,0);
   stddev = iStdDev(Symbol(),0,BPeriod,0,MODE_SMA,PRICE_OPEN,0);
   //Print(iBands(Symbol(),0,BPeriod,Deviation,0,PRICE_CLOSE,MODE_SIGNAL,0));
   bup = ma+(Deviation*stddev);
   bdn = ma-(Deviation*stddev);

   bux=(bup+(BDistance*Point));
   bdx=(bdn-(BDistance*Point));
      

//+------------------------------------------------------------------+
//| Stop Loss Protection for MA                                      |
//+------------------------------------------------------------------+ 

  if(MCEmergencyStop) { 
  
      int Buy_ESL = 0;
      int Sell_ESL = 0;
      double TotalProfit = 0;
  
      // Test
      for(int ESL=0; ESL<=5; ESL++)
      { 
         // If Price is lower then MA and Stoch. shows sell, then it should be Emergency Stop Lossed
         if(Bid<iMA(Symbol(),0,MA_Period,0,MODE_SMA,PRICE_CLOSE,ESL))
         {
            Buy_ESL++;
         }
         // If Price is higher then MA and Stoch. shows buy, then it should be Emergency Stop Lossed
         if(Bid>iMA(Symbol(),0,MA_Period,0,MODE_SMA,PRICE_CLOSE,ESL))
         {
            Sell_ESL++;
         }
         
      }     

      if ( Buy_ESL >= 4 )
      {
         //Print("Buy Close");
         for(int s=OrdersTotal()-1; s>=0; s--)
         { 
            OrderSelect(s, SELECT_BY_POS, MODE_TRADES);
            TotalProfit = TotalProfit + OrderProfit();                     
         }
         if (TotalProfit <= MCEmergencyValue) {
             ExitAllTradesDirection(Red, "Csak", "Buy");                         
             return(0);                      
         }
          
      }
      if (  Sell_ESL >= 4 )
      {
         for(int b=OrdersTotal()-1; b>=0; b--)
         { 
            OrderSelect(b, SELECT_BY_POS, MODE_TRADES);
            TotalProfit = TotalProfit + OrderProfit();                     
         }
         if (TotalProfit <= MCEmergencyValue) {
             ExitAllTradesDirection(Red, "Csak", "Sell");                         
             return(0);                      
         }
      }      
 }



 //ExitAllTrades(color Color, string reason)   


   
  
//+------------------------------------------------------------------+
//| Calculate Total Profits and Total Orders                         |
//+------------------------------------------------------------------+ 
for (y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUY)) {
        cb++;
        pr=pr+OrderProfit();
        tbl=tbl+OrderLots();
      }
      if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELL)) {
        cs++;
        pr=pr+OrderProfit();
        tsl=tsl+OrderLots();
      }
      if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUYLIMIT)) cbl++;
      if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELLLIMIT)) csl++;
      if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUYSTOP)) cbs++;
      if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELLSTOP)) css++;
      tl=tbl+tsl;
      to=cb+cs;}
      
//+------------------------------------------------------------------+
//| Account Protection                                               |
//+------------------------------------------------------------------+ 
  
  PortionBalance = NormalizeDouble(AccountBalance()/Portion,2);
  PortionEquity  = NormalizeDouble(PortionBalance + pr,2);
  if(UseEquityProtection) {
       if ( PortionBalance - PortionEquity >= (PortionBalance * FloatPercent/100) )  
               ExitAllTrades(Red,"Equity Stop Loss Reached");}  
               
//+------------------------------------------------------------------+
//| check for Friday close and prevent placig                        |
//| new orders after the Friday close time                           |
//+------------------------------------------------------------------+    
  
if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
{
   if (TimeHour(TimeCurrent()) > FridayCloseHour ||
      (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
   {
      for(int i=OrdersTotal()-1; i>=0; i--)
      { 
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol()     !=Symbol())    continue;
         if(OrderMagicNumber()!=magic) continue;

         if(OrderType()==OP_BUYSTOP)  { OrderDelete(OrderTicket(),CLR_NONE);                  continue; }
         if(OrderType()==OP_SELLSTOP) { OrderDelete(OrderTicket(),CLR_NONE);                  continue; }
         if(OrderType()==OP_BUY)      { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,CLR_NONE); continue; }
         if(OrderType()==OP_SELL)     { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,CLR_NONE); continue; }
      }
   return(0);
   }
}   


//+------------------------------------------------------------------+
//| Trade when high volatility is possible (1H after market opens)   |
//+------------------------------------------------------------------+    
  
if (  TradeDelay &&
      (
         (TimeHour(TimeCurrent()) < NYOpenHour && TimeHour(TimeCurrent()) > NYCloseHour) ||
         (TimeHour(TimeCurrent()) < TokyoOpenHour && TimeHour(TimeCurrent()) > TokyoCloseHour) ||
         (TimeHour(TimeCurrent()) < LondonOpenHour && TimeHour(TimeCurrent()) > LondonCloseHour)
      )
   )
{
   for(int x=OrdersTotal()-1; x>=0; x--)
   { 
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()     !=Symbol())    continue;
      if(OrderMagicNumber()!=magic) continue;

      if(OrderType()==OP_BUYSTOP)  { OrderDelete(OrderTicket(),CLR_NONE);                  continue; }
      if(OrderType()==OP_SELLSTOP) { OrderDelete(OrderTicket(),CLR_NONE);                  continue; }
      if(OrderType()==OP_BUY)      { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,CLR_NONE); continue; }
      if(OrderType()==OP_SELL)     { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,CLR_NONE); continue; }
   }
   return(0);
}


//+------------------------------------------------------------------+
//| Trading with EA Criteria                                         |
//+------------------------------------------------------------------+

  InitialAccountMultiPortion = InitialAccount/Portion;
      if (PortionBalance < InitialAccountMultiPortion){ 
            //PlaySound("alert.wav");
            //Print("Account Balance is less than Initial Account Balance setting"); 
            Print( "Account Balance is less than Initial Account Balance on " + Symbol()+ Period(), "Centurion: Warning" );
  return(0);}

//+------------------------------------------------------------------+
//| Power Out Stop Loss Protection                                   |
//+------------------------------------------------------------------+ 

  if(UsePowerOutSL) {
     POSL_On = "Yes";
     int correct = 1;
     double pipvalue=MarketInfo(Symbol(),MODE_TICKVALUE);
     if(Accounttype == 1 && pipvalue < 5) correct = 10;
     if(tl == 0){
       POSL = 600;
       if(Digits==3 || Digits==5) POSL = POSL * 10;
       buysl = Ask - POSL * Point;
       sellsl= Bid + POSL * Point;}
    
     if(tl > 0){
       POSL =  NormalizeDouble((PortionBalance * (FloatPercent + 1)/100)/(pipvalue * tl * correct),0);
       if(POSL > 600) POSL = 600;
       if(Digits==3 || Digits==5) POSL = POSL * 10;
       buysl = Ask - POSL * Point;
       sellsl= Bid + POSL * Point;}
       
     if(to == 0) count = 0;
     if(to > 0 && to > count){
     
     // sync up order stop losses
     for (int q = 0; q < OrdersTotal(); q++) {
        OrderSelect (q, SELECT_BY_POS, MODE_TRADES);
        if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUY)) {
            OrderModify(OrderTicket(), OrderOpenPrice(), buysl, OrderTakeProfit(), 0, Purple);
            query=StringConcatenate("insert into mt4 (Param_01,Param_02,Param_03,Param_04,Param_05,Param_06,Param_07)value(\"MOD_OP_BUY\",\"",OrderTicket(),"\",\"",OrderOpenPrice(),"\",\"",buysl,"\",\"",OrderTakeProfit(),"\",\"",false,"\",\"",false,"\")");
            //SocketSend(query);
            }
        if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELL)) {
            OrderModify(OrderTicket(), OrderOpenPrice(), sellsl, OrderTakeProfit(), 0, Purple);
            query=StringConcatenate("insert into mt4 (Param_01,Param_02,Param_03,Param_04,Param_05,Param_06,Param_07)value(\"MOD_OP_SELL\",\"",OrderTicket(),"\",\"",OrderOpenPrice(),"\",\"",sellsl,"\",\"",OrderTakeProfit(),"\",\"",false,"\",\"",false,"\")");  
            //SocketSend(query);
            } } } 
        count = to;}
        
        
//+------------------------------------------------------------------+
//| Money Management and Lot size coding                             |
//+------------------------------------------------------------------+
   
  if(UseMM){

  double Contracts, Factor, Lotsize;

          Contracts = (AccountBalance()/10000)/Portion;
          Factor    = Multiplier+
                MathPow(Multiplier,2)+
                MathPow(Multiplier,3)+
                MathPow(Multiplier,4)+
                MathPow(Multiplier,5)+
                MathPow(Multiplier,6);

          Lotsize=LAF*Accounttype*(Contracts/(1.0 + Factor));

    //Determine Lot size boundries from minimum to maximum

          lot=NormalizeDouble(Lotsize,2);

          if(Lotsize<0.01) lot=0.01;
          if(Lotsize>100/MathPow(Multiplier,6) && Accounttype == 1) lot=NormalizeDouble(100/MathPow(Multiplier,6),2);
          if(Lotsize>50/MathPow(Multiplier,6)  && Accounttype == 10) lot=NormalizeDouble(50/MathPow(Multiplier,6),2);}

//+------------------------------------------------------------------+
//| ATR to autocalculate the Grid                                    | 
//+------------------------------------------------------------------+     

  double GridStart,value1;
  double atrvalue = iATR(NULL,AutoCalTF,AutoCalPeriod,0);  // Bobster added external variables; default is 1440, 21
    if(AutoCal==True){
      if(Digits == 2 || Digits == 3) value1 = atrvalue*100;
      if(Digits == 4 || Digits == 5) value1 = atrvalue*10000;
      GridStart = value1*2/10;
      GridSet1  = GridStart;
      TP_Set1   = GridStart + GridSet1;
      GridSet2  = TP_Set1;
      TP_Set2   = (GridStart + GridSet1) * 2;
      GridSet3  = TP_Set2;
      TP_Set3   = (GridStart + GridSet1) * 4;}       
 
//+------------------------------------------------------------------+
//| Moving Average Indicator for Calculation of Trend Direction      |
//+------------------------------------------------------------------+      

  int Buy_Trend = 0;
  int Sell_Trend = 0;
  MC=-1;
    
  if (MCbyMA) {
  
      int Treshold = 4;

      // Test
      for(int Trend=0; Trend<=4; Trend++)
      { 
         // If Price is lower then MA and Stoch. shows sell, then it should be Emergency Stop Lossed
         if(
            Bid<iMA(Symbol(),MA_TimeFrame,MA_Period,0,MA_Type,PRICE_CLOSE,Trend) 
            && Bid<iMA(Symbol(),MA_TimeFrame,MA_Period_Fast,0,MA_Type,PRICE_HIGH,Trend)
            && iForce (Symbol(), MA_TimeFrame, ForceP, MA_Type, PRICE_CLOSE, Trend) < 0
            && iDeMarker(Symbol(),DeMark_TimeFrame,DeMark_Period,Trend) < DeMark_Buy_Zone
            //&& iSAR(Symbol(),0,SAR_Trend,SAR_Max,Trend) > Close[Trend]
            )
         {
            Sell_Trend++;
         }
         // If Price is higher then MA and Stoch. shows buy, then it should be Emergency Stop Lossed
         if(
            Bid>iMA(Symbol(),MA_TimeFrame,MA_Period,0,MA_Type,PRICE_CLOSE,Trend) 
            && Bid>iMA(Symbol(),MA_TimeFrame,MA_Period_Fast,0,MA_Type,PRICE_HIGH,Trend)
            && iForce (Symbol(), MA_TimeFrame, ForceP, MA_Type, PRICE_CLOSE, Trend) > 0
            && iDeMarker(Symbol(),DeMark_TimeFrame,DeMark_Period,Trend) > DeMark_Sell_Zone
            //&& iSAR(Symbol(),0,SAR_Trend,SAR_Max,Trend) < Close[Trend]
            )
         {
            Buy_Trend++;
         }
         
      } 
  
     
     if (Buy_Trend >= Treshold) MC=0;
     if (Sell_Trend >= Treshold) MC=1;
     
     
  } else {  
     
     if (iSAR(Symbol(),0,SAR_Trend,SAR_Max,1) > Close[1] 
         && iSAR(Symbol(),0,SAR_Trend,SAR_Max,2) > Close[2] 
         && iSAR(Symbol(),0,SAR_Trend,SAR_Max,3) > Close[3])
     {
      MC=1;   
     }
     
     if (iSAR(Symbol(),0,SAR_Trend,SAR_Max,1) < Close[1] 
         && iSAR(Symbol(),0,SAR_Trend,SAR_Max,2) < Close[2] 
         && iSAR(Symbol(),0,SAR_Trend,SAR_Max,3) < Close[3])
     {
      MC=0;   
     }
     
/*
     if (Close[0] > bux && iStochastic(NULL,0,15,2,2,MODE_LWMA,1,0,1) > 80 && iStochastic(NULL,0,15,2,2,MODE_LWMA,1,1,1) > 80)
     {
      Sell_Trend = 10000;
     }
     if (Close[0] < bdx && iStochastic(NULL,0,15,2,2,MODE_LWMA,1,0,1) < 20 && iStochastic(NULL,0,15,2,2,MODE_LWMA,1,1,1) < 20)
     {
      Buy_Trend = 10000;
     }
*/     
     
     
  
  
  }
  
     
     
     
  if (MC==0) trendUpDown = "UP";
  
  if (MC==1) trendUpDown = "DOWN";

  if (MC==-1) trendUpDown = "NONE";
  

  
  double         Balance             = AccountBalance();
  double         Equity              = AccountEquity();
  
  //Print(trendUpDown);
  
  DD = Balance - Equity;
  
  if (DD > MaxDD) MaxDD = DD;
  
  MaxDDpercent = (MaxDD / Balance) * 100;
  
  
      

//+------------------------------------------------------------------+
//| Blessing Code                                                    |
//+------------------------------------------------------------------+   

  if (cs==0 && cb==0 && cbs==0 && cbl==0 && css==0 && csl==0) ca=false;
     
   slip = NormalizeDouble((slippage * BrokerDecimal),0);
  
   if (((cb>=BELevel || cs>=BELevel) && pr>0) || ca) {
     ca=true;
     for (y = 0; y < OrdersTotal(); y++){
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUY || OrderType()==OP_SELL)) OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slip,Lime);       
       if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT || OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)) OrderDelete(OrderTicket(),White);}
       if (OrderCloseTime () != 0) {
            
            if (OrderProfit() >= 0) {
              Print("Profit Good");
              
            } else {
              Print("Profit Bad");
              
            }
       }
     return;}

      d = d;
      if (BrokerDecimal == 10) d=50;
      g2=GridSet1;
      tp2=TP_Set1;

   if (cb>=Set1Count || cs>=Set1Count) {
     g2=GridSet2;
     tp2=TP_Set2;}

   if (cb>=Set2Count+Set1Count || cs>=Set2Count+Set1Count) {
     g2=GridSet3;
     tp2=TP_Set3;}
   
//+------------------------------------------------------------------+
//| Broker Decimal Selection                                         |
//+------------------------------------------------------------------+ 

  if (BrokerDecimal == 10){
     g2 *= 10;
     tp2 *= 10;}

//+------------------------------------------------------------------+
//| Adjust Grid and Normalize Values                                 |
//+------------------------------------------------------------------+

  g2  = NormalizeDouble(g2*GAF,0);
  tp2 = NormalizeDouble(tp2*GAF,0);
  

//+------------------------------------------------------------------+
//| Trade Decision                                                   |
//+------------------------------------------------------------------+   

// Calculates the total indicators that has been enabled
double TotalIndicators = 0.0;
if(Bollinger == true) { TotalIndicators++; }
if(OsMA == true) { TotalIndicators++; }
if(Stoch == true) { TotalIndicators++; }
if(SAR == true) { TotalIndicators++; }
if(Williams == true) { TotalIndicators++; }
if(RSI == true) { TotalIndicators++; }


// MACD
string iOSMA = "Stay";

if(OsMA == true)
   {
   double OsMACurrent=iOsMA(NULL,0,FastEMA,SlowEMA,Signal,PRICE_CLOSE,0);
   double OsMAPrev01=iOsMA(NULL,0,FastEMA,SlowEMA,Signal,PRICE_CLOSE,1);
   double OsMAPrev02=iOsMA(NULL,0,FastEMA,SlowEMA,Signal,PRICE_CLOSE,2);   

   if(OsMACurrent > OsMAPrev01)
   //if(OsMACurrent > 0 && OsMAPrev01 > 0 && OsMAPrev02 > 0)
      {
         iOSMA = "Buy";
      }
   
   if(OsMACurrent < OsMAPrev01)
   //if(OsMACurrent < 0 && OsMAPrev01 < 0 && OsMAPrev02 < 0)
      {
         iOSMA = "Sell";
      }
}

// Stochastic
// 0 - MODE_MAIN
// 1 - MODE_SIGNAL
string iStoch = "Stay";
if(Stoch == true)
   {
   if(
      iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,0,1) > iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)
      && iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1) > zoneBUY
      && iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1) < zoneSELL
      )
   {
      iStoch = "Buy";  
   }

   if(
      iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,0,1) < iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)      
      && iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1) > zoneBUY
      && iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1) < zoneSELL
      )
   {
      iStoch = "Sell";    
   }
}


// Stochastic
string iSar = "Stay";
if(SAR == true)
   {
   if(iSAR(NULL,0,SAR_Step,SAR_Max,1) < Close[1])
   {
      iSar = "Buy";  
   }

   if(iSAR(NULL,0,SAR_Step,SAR_Max,1) > Close[1])
   {
      iSar = "Sell";    
   }
}


// Williams
string iWilliams = "Stay";
if(Williams == true)
   {
   if(iWPR(NULL, 0, WilliamsP, 1) < WilliamsH)
   {
      iWilliams = "Buy";  
   }

   if(iWPR(NULL, 0, WilliamsP, 1) < WilliamsL)
   {
      iWilliams = "Sell";    
   }
}

// Bollinger
string iBollinger = "Stay";
if(Bollinger == true)
{
   if(Close[0] > bux)
   {
      iBollinger = "Sell";
   }
   
   if(Close[0] < bdx)
   {
      iBollinger = "Buy";
   }   
}

// RSI
string iRsi = "Stay";
if(RSI == true)
{
   if(iRSI(Symbol(),0,RSI_Period,PRICE_WEIGHTED,0) < RSI_BuyZone)
   {
      iRsi = "Buy";
   }
   
   if(iRSI(Symbol(),0,RSI_Period,PRICE_WEIGHTED,0) > RSI_SellZone)
   {
      iRsi = "Sell";
   }   
}

//if(iBollinger != "Stay") { Print(iBollinger); }
int Buy_Signals = 0;
int Sell_Signals = 0;

if(iOSMA == "Buy") { Buy_Signals++; }
if(iSar == "Buy") { Buy_Signals++; }
if(iWilliams == "Buy") { Buy_Signals++; }
if(iBollinger == "Buy") { Buy_Signals++; }
if(iStoch == "Buy") { Buy_Signals++; }
if(iRsi == "Buy") { Buy_Signals++; }

if(iOSMA == "Sell") { Sell_Signals++; }
if(iSar == "Sell") { Sell_Signals++; }
if(iWilliams == "Sell") { Sell_Signals++; }
if(iBollinger == "Sell") { Sell_Signals++; }
if(iStoch == "Sell") { Sell_Signals++; }
if(iRsi == "Sell") { Sell_Signals++; }



 string iFinal = "Stay";

 
   if(Buy_Signals / TotalIndicators > IndicatorsPercent && MC == 0)
   {
      if (MCE_TradeOK == true)
      {
         iFinal = "Buy";
      }else{
         MCE_TradeOK = true;
      }
   } 
 
   if(Sell_Signals / TotalIndicators > IndicatorsPercent && MC == 1)
   {
      if (MCE_TradeOK == true)
      {
         iFinal = "Sell";
      }else{
         MCE_TradeOK = true;
      }
   }
 


if(trendUpDown != "ALMA")
{
 //Print(iOSMA);
 Print("Buy_Signal: ",Buy_Signals / TotalIndicators);
 Print("Sell_Signal: ",Sell_Signals / TotalIndicators);
 Print("Total_Signal: ",TotalIndicators);
 Print(iFinal);
 Print("Trend: ",trendUpDown);
}





//+------------------------------------------------------------------+
//| Trade Selection Logic                                            |
//+------------------------------------------------------------------+ 

   if ((cb==0) && (cs==0)) {
     for (y = 0; y < OrdersTotal(); y++)
     {
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderLots()>lot))
       {
         OrderDelete(OrderTicket()); 
         
       }
       
     }
       
      if (MC==0) {
   
         if (iFinal == "Buy")
         {
            if (cbs==0) {
               OrderSend(Symbol(),OP_BUY,lot,Ask,0,buysl,Ask+tp2*Point,TradeComment,magic,0,Blue);
               CloseBuySellLimitOrders = true;
               return;
            }
         }
      }
      if (MC==1) {
   
         if (iFinal == "Sell")
         {
            if (css==0) {
               OrderSend(Symbol(),OP_SELL,lot,Bid,0,sellsl,Bid-tp2*Point,TradeComment,magic,0,Red);
               
               CloseBuySellLimitOrders = true;
               return;
            }
         }
      }
      
   }

	if (CloseBuySellLimitOrders)
	{
		for (y = 0; y < OrdersTotal(); y++)
		{
			OrderSelect (y, SELECT_BY_POS, MODE_TRADES);

			if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()!=OP_SELL) && (OrderType()!=OP_BUY) && OrderLots()==lot)
			{
				OrderDelete(OrderTicket());
			}
		}
	}
   
   if (cb>0) {
     sumlot=0;
     mp=0;
     for (y = 0; y < OrdersTotal(); y++){
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       if ((OrderMagicNumber() != magic) || (OrderType()!=OP_BUY) || (OrderSymbol()!=Symbol())) { continue; }
       lp=OrderOpenPrice();
       ll=OrderLots();
       ltp=OrderTakeProfit();
       lopt=OrderOpenTime();
       lticket=OrderTicket();
       sumlot=sumlot+ll;
       mp=mp+ll*lp;}
      
       mp=mp/sumlot;
 
   if ((TimeCurrent()-TimeGrid>lopt) && (cb<MaxLevel)) {
         if (lp>Ask) entry=NormalizeDouble(lp-(MathRound((lp-Ask)/Point/g2)+1)*g2*Point,Digits); else entry=NormalizeDouble(lp-g2*Point,Digits);
         if (ll <= 0.01) lot2=NormalizeDouble(ll*2+LotInc,2); else lot2=NormalizeDouble(ll*Multiplier+LotInc,2);
       
         if (cbl==0 && MC==0) {
           OrderSend(Symbol(),OP_BUYLIMIT,lot2,entry,0,buysl,entry+tp2*Point,TradeComment,magic);
           Print("s3");
           return;}

         if (cbl==1) {
           for (y = 0; y < OrdersTotal(); y++){
              OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
              if (OrderType()==OP_BUYLIMIT && OrderMagicNumber()==magic && (OrderSymbol()==Symbol()) && entry-OrderOpenPrice()>g2/2*Point) { // ,,,
                OrderModify(OrderTicket(),entry,buysl,entry+tp2*Point,0);

                Print("mo1");} } } } 
         
         for (y = 0; y < OrdersTotal(); y++){ // Sync TPs
           OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
           if ((OrderMagicNumber() != magic) || (OrderType()!=OP_BUY) || (MathAbs(OrderTakeProfit()-ltp)<Point) || (OrderSymbol()!=Symbol())) { continue; }
           OrderModify(OrderTicket(),OrderOpenPrice(),buysl,ltp,0,Blue);

           Print("m1");
           return;} }

   if (cs>0) {
     sumlot=0;
     mp=0;
     for (y = 0; y < OrdersTotal(); y++){
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       if ((OrderMagicNumber() != magic) || (OrderType()!=OP_SELL) || (OrderSymbol()!=Symbol())) { continue; }
       lp=OrderOpenPrice();
       ll=OrderLots();
       ltp=OrderTakeProfit();
       lopt=OrderOpenTime();
       lticket=OrderTicket();
       sumlot=sumlot+ll;
       mp=mp+ll*lp;}
      
       mp=mp/sumlot;
 
   if ((TimeCurrent()-TimeGrid>lopt) && (cs<MaxLevel)) {
         if (Bid>lp) entry=NormalizeDouble(lp+(MathRound((-lp+Bid)/Point/g2)+1)*g2*Point,Digits); else entry=NormalizeDouble(lp+g2*Point,Digits);
         if (ll <= 0.01) lot2=NormalizeDouble(ll*2+LotInc,2); else lot2=NormalizeDouble(ll*Multiplier+LotInc,2);
         
         if (csl==0 && MC==1) {
            OrderSend(Symbol(),OP_SELLLIMIT,lot2,entry,0,sellsl,entry-tp2*Point,TradeComment,magic);
            Print("s4");
            return;}

         if (csl==1) {
           for (y = 0; y < OrdersTotal(); y++)           {
              OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
              if (OrderType()==OP_SELLLIMIT && OrderMagicNumber()==magic && (OrderSymbol()==Symbol()) && OrderOpenPrice()-entry>g2/2*Point) {
              OrderModify(OrderTicket(),entry,sellsl,entry-tp2*Point,0);
              Print(query);
              Print("mo2");} } } }

        for (y = 0; y < OrdersTotal(); y++){ // Sync TPs
          OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
          if ((OrderMagicNumber() != magic) || (OrderType()!=OP_SELL) || (MathAbs(OrderTakeProfit()-ltp)<Point) || (OrderSymbol()!=Symbol())) { continue; }
          OrderModify(OrderTicket(),OrderOpenPrice(),sellsl,ltp,0,Red);

          Print("m2");
          return;} }
             
//+------------------------------------------------------------------+
//| External Script Code                                             |
//+------------------------------------------------------------------+
 
  string Message;

   Message = "                "+EA_name + NL +
             "                            Current Time is      " +  TimeToStr(TimeCurrent(), TIME_SECONDS) + NL + NL +                        
             "                            Initial Account Set              " + DoubleToStr(InitialAccount, 0) + NL + NL +
             "                            Equity Protection % Set      " + DoubleToStr(FloatPercent, 0) + NL + NL +
             "                            Power Off Stop Loss on?         " + POSL_On + NL + NL +     
             "                            Starting lot size                   " + DoubleToStr(lot, 2) + NL + NL +

             "                            Portion P/L                        " + DoubleToStr(pr, 2) + NL + NL +     
             
             "                            Buy   " + cb + "  Sell   " + cs + NL + NL +
             "                            Account Portion   " + DoubleToStr(Portion, 0) + "   Total Risk on Account Percent  " + DoubleToStr(FloatPercent/Portion, 0) + NL + NL +                
             "                            Portion Balance      " + DoubleToStr(PortionBalance, 2) + "    TREND : " + trendUpDown + NL + NL+
             "                            Equity : " + DoubleToStr(Equity,2) + NL + NL +
             "                            DrawDown : " + DoubleToStr(DD,2) + NL + NL +
             "                            Max DD : " + DoubleToStr(MaxDD,2) + "   Max DD Percent : " + DoubleToStr(MaxDDpercent,2) + " %";
                                         
             

   Comment(Message); 
   
    
return(0);
}
 
//+------------------------------------------------------------------+
//| Exit Trade Function                                              |
//+------------------------------------------------------------------+ 

  void ExitAllTrades(color Color, string reason){
    slip = NormalizeDouble((slippage * BrokerDecimal),0);
    bool success;
    for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic){
         OrderDelete(OrderTicket(),Color);
         success=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), slip, Color);
         if(success==true){
            Print("Closed all positions because ",reason);} } } }   
            

  void ExitAllTradesDirection(color Color, string reason, string direction){
    slip = NormalizeDouble((slippage * BrokerDecimal),0);
    bool success;
    for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic){
         if((OrderType()==OP_BUY || OrderType()==OP_BUYSTOP) && direction == "Buy")         
         {
            OrderDelete(OrderTicket(),Color);
            success=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), slip, Color);
         }
         if((OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) && direction == "Sell")         
         {
            OrderDelete(OrderTicket(),Color);
            success=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), slip, Color);
         }
         if(success==true){
            Print("Closed all positions because ",reason); return(0);} } } }   

         

//+------------------------------------------------------------------+
//| expert end function                                              |
//+------------------------------------------------------------------+